layerscape: update restool to 2017-12-03
[openwrt/openwrt.git] / scripts / bundle-libraries.sh
1 #!/usr/bin/env bash
2 #
3 # Script to install host system binaries along with required libraries.
4 #
5 # Copyright (C) 2012-2017 Jo-Philipp Wich <jo@mein.io>
6 #
7 # This program is free software; you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation; either version 2 of the License, or
10 # (at your option) any later version.
11 #
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 # GNU General Public License for more details.
16 #
17 # You should have received a copy of the GNU General Public License
18 # along with this program; if not, write to the Free Software
19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
20
21 DIR="$1"; shift
22
23 _cp() {
24 cp ${VERBOSE:+-v} -L "$1" "$2" || {
25 echo "cp($1 $2) failed" >&2
26 exit 1
27 }
28 }
29
30 _mv() {
31 mv ${VERBOSE:+-v} "$1" "$2" || {
32 echo "mv($1 $2) failed" >&2
33 exit 1
34 }
35 }
36
37 _md() {
38 mkdir ${VERBOSE:+-v} -p "$1" || {
39 echo "mkdir($1) failed" >&2
40 exit 2
41 }
42 }
43
44 _ln() {
45 ln ${VERBOSE:+-v} -sf "$1" "$2" || {
46 echo "ln($1 $2) failed" >&2
47 exit 3
48 }
49 }
50
51 _relpath() {
52 local base="$(readlink -f "$1")"
53 local dest="$(readlink -f "$2")"
54 local up
55
56 [ -d "$base" ] || base="${base%/*}"
57 [ -d "$dest" ] || dest="${dest%/*}"
58
59 while true; do
60 case "$base"
61 in "$dest"/*)
62 echo "$up/${base#$dest/}"
63 break
64 ;;
65 *)
66 dest="${dest%/*}"
67 up="${up:+$up/}.."
68 ;;
69 esac
70 done
71 }
72
73 _runas_so() {
74 cat <<-EOT | ${CC:-gcc} -x c -fPIC -shared -o "$1" -
75 #include <unistd.h>
76 #include <stdio.h>
77 #include <stdlib.h>
78
79 int mangle_arg0(int argc, char **argv, char **env) {
80 char *arg0 = getenv("RUNAS_ARG0");
81
82 if (arg0) {
83 argv[0] = arg0;
84 unsetenv("RUNAS_ARG0");
85 }
86
87 return 0;
88 }
89
90 __attribute__((section(".init_array")))
91 static void *mangle_arg0_constructor = &mangle_arg0;
92 EOT
93
94 [ -x "$1" ] || {
95 echo "compiling preload library failed" >&2
96 exit 5
97 }
98 }
99
100 _patch_ldso() {
101 _cp "$1" "$1.patched"
102 sed -i -e 's,/\(usr\|lib\|etc\)/,/###/,g' "$1.patched"
103
104 if "$1.patched" 2>&1 | grep -q -- --library-path; then
105 _mv "$1.patched" "$1"
106 else
107 echo "binary patched ${1##*/} not executable, using original" >&2
108 rm -f "$1.patched"
109 fi
110 }
111
112 for LDD in ${PATH//://ldd }/ldd; do
113 "$LDD" --version >/dev/null 2>/dev/null && break
114 LDD=""
115 done
116
117 [ -n "$LDD" -a -x "$LDD" ] || LDD=
118
119 for BIN in "$@"; do
120 [ -n "$BIN" -a -n "$DIR" ] || {
121 echo "Usage: $0 <destdir> <executable> ..." >&2
122 exit 1
123 }
124
125 [ ! -d "$DIR/lib" ] && {
126 _md "$DIR/lib"
127 _md "$DIR/usr"
128 _ln "../lib" "$DIR/usr/lib"
129 }
130
131 [ ! -x "$DIR/lib/runas.so" ] && {
132 _runas_so "$DIR/lib/runas.so"
133 }
134
135 LDSO=""
136
137 [ -n "$LDD" ] && [ -x "$BIN" ] && file "$BIN" | grep -sqE "ELF.*(executable|interpreter)" && {
138 for token in $("$LDD" "$BIN" 2>/dev/null); do
139 case "$token" in */*.so*)
140 case "$token" in
141 *ld-*.so*) LDSO="${token##*/}" ;;
142 esac
143
144 dest="$DIR/lib/${token##*/}"
145 ddir="${dest%/*}"
146
147 [ -f "$token" -a ! -f "$dest" ] && {
148 _md "$ddir"
149 _cp "$token" "$dest"
150 [ -n "$LDSO" ] && _patch_ldso "$dest"
151 }
152 ;; esac
153 done
154 }
155
156 # is a dynamically linked executable
157 if [ -n "$LDSO" ]; then
158 echo "Bundling ${BIN##*/}"
159
160 RUNDIR="$(readlink -f "$BIN")"; RUNDIR="${RUNDIR%/*}"
161 RUN="${LDSO#ld-}"; RUN="run-${RUN%%.so*}.sh"
162 REL="$(_relpath "$DIR/lib" "$BIN")"
163
164 _mv "$BIN" "$RUNDIR/.${BIN##*/}.bin"
165
166 cat <<-EOF > "$BIN"
167 #!/usr/bin/env bash
168 dir="\$(dirname "\$0")"
169 export RUNAS_ARG0="\$0"
170 export LD_PRELOAD="\$dir/${REL:+$REL/}runas.so"
171 exec "\$dir/${REL:+$REL/}$LDSO" --library-path "\$dir/${REL:+$REL/}" "\$dir/.${BIN##*/}.bin" "\$@"
172 EOF
173
174 chmod ${VERBOSE:+-v} 0755 "$BIN"
175 fi
176 done